// This file can replace global.js in karma.

function padLeft(str, pad_character, length) {
    str = str.toString();
    pad_character = pad_character.toString();
    while (str.length < length) {
        str = pad_character + str;
    }
    return str;
}

function playAudio(karma, clip){
    karma.play(clip)
    $('#mediaPlay').hide();
    $('#mediaPause').addClass('mediaPause').show();
    /*
    clip.media.addEventListener('ended',function (e) {
         $('#mediaPause').hide();
         $('#mediaPlay').show();
         });
    */
    };

function pauseAudio(karma, clip){
    karma.pause(clip);
    $('#mediaPause').hide();
    $('#mediaPlay').show();
    };

function playVideo(karma, clip){
    karma.play(clip)
    $('#mediaPlay').hide();
    $('#mediaPause').addClass('mediaPause').show();
    /*
    clip.media.addEventListener('ended',function (e) {
         $('#mediaPause').hide();
         $('#mediaPlay').show();
         });
    */
    };

function pauseVideo(karma, clip){
    karma.pause(clip);
    $('#mediaPause').hide();
    $('#mediaPlay').show();
    };

function controlButtonClickCallback($button, callback) {
    $button.click(function () {
                      if (!$button.data('disabled')) {
                          callback();
                      }
                  });
}

function enableControlButton($button) {
    $button
        .css({opacity: 1, cursor: 'pointer'})
        .data('disabled', false);
}

function disableControlButton($button) {
    $button
        .css({opacity: 0.3, cursor: 'default'})
        .data('disabled', true);
}

function setUpLinkBackLesson() {
    $('#linkBackLesson')
        .click(function () {
                   window.location = '../../../MenuStage.html';
               });
}

/*
*audio routines based on play.py and record.py
*these can be replaced by the karma routines below when
*the problem with handling media in karma on the 'new build' is resolved
*/

function playClip(clip){
  host = 'http://localhost:8008/'
  $('#dummy')
    .load(host+'cgi-bin/play.py',{src:clip});
};

function recordAudio(clip){ // this is a little more complicated
  host = 'http://localhost:8008/'
  $('#recordAudio')
      .addClass('recordAudio')
      .toggle(
          function(){ // record clip
              $(this)
                  .removeClass('recordAudio')
                  .addClass('stopAudio')
              $('#dummy')
                  .load(host+'cgi-bin/record.py',{src:clip})
              $('#playAudio')
                  .removeClass('playAudio')
                  .removeClass('pauseAudio')
          },
          function(){ // stop recording, enable playback
               $(this)
                  .removeClass('pauseAudio')
                  .addClass('playAudio')
              $('#dummy')
                  .load(host+'cgi-bin/play.py')
               $('#playAudio')
                  .addClass('playAudio')
          })
}

function playXoAudio(clip){ //play the pre-recorded clip to compare with the student's version
  host = 'http://localhost:8008/'
  $('#playXoAudio')
      .addClass('playXoAudio')
      .toggle(
          function(){ // play clip
              $(this)
                  .removeClass('playXoAudio')
                  .addClass('pauseXoAudio')
              $('#dummy')
                  .load(host+'cgi-bin/play.py',{src:clip})
          },
          function(){ // pause clip
               $(this)
                  .removeClass('pauseXoAudio')
                  .addClass('playXoAudio')
              $('#dummy')
                  .load(host+'cgi-bin/play.py')
          })
}

function playHelp(clip){ //play the help clip for this screen
  host = 'http://localhost:8008/'
  $('#linkHelp')
      .addClass('linkHelp')
      .toggle(
          function(){ // play clip
              $(this)
                  .removeClass('linkHelp')
                  .addClass('pauseHelp')
              $('#dummy')
                  .load(host+'cgi-bin/play.py',{src:clip})
          },
          function(){ // pause clip
               $(this)
                  .removeClass('pauseHelp')
                  .addClass('linkHelp')
              $('#dummy')
                  .load(host+'cgi-bin/play.py')
          })
}

function sayText(text){ //use espeak to say the text clip
  host = 'http://localhost:8008/'
  $('#sayText')
      .addClass('sayText')
      .toggle(
          function(){ // play clip
              $(this)
                  .removeClass('sayText')
                  .addClass('stopText')
              $('#dummy')
                  .load(host+'cgi-bin/say.py',{src:clip})
          },
          function(){ // pause clip
               $(this)
                  .removeClass('stopText')
                  .addClass('sayText')
              $('#dummy')
                  .load(host+'cgi-bin/say.py')
          })
}

/*
 * You need a localhost server, and load the index.html through this
 * server to be able to do the 'load' calls (same origin policy).
 * You also need an implementation of the record.py and stop_recording.py
 * scripts.
 */
function setUpRecordingButtons(karma) {
    var record_button = $('#linkRecordAudio');
    var play_button = $('#linkPlayRecordedAudio');
    var is_recording = false;
    var is_playing = false;
    var recorded_audio;
    var finished_recording = function () {
        is_recording = false;
        record_button.text('Record');
        disableControlButton(record_button);
        recorded_audio = new Audio;
        // TBD: name should change with each recording, otherwise it is cached
        // One way to do this, is to keep a counter in js and pass the name
        // of a file as an argument to the record.py script.
        recorded_audio.src = '/recorded.ogg';
        recorded_audio.addEventListener('canplaythrough',
                                        function (e) {
                                            enableControlButton(record_button);
                                            enableControlButton(play_button);
                                        },
                                        false);
        recorded_audio.autobuffer = true;
        recorded_audio.load();
    };
    controlButtonClickCallback(play_button,
                               function () {
                                   if (!is_playing) {
                                       disableControlButton(record_button);
                                       recorded_audio.play();
                                       is_playing = true;
                                       play_button.text('Pause');
                                       recorded_audio.addEventListener
                                       ('ended',
                                        function (e) {
                                            is_playing = false;
                                            play_button.text('Play');
                                            enableControlButton(record_button);
                                        },
                                        false);
                                   } else {
                                       recorded_audio.pause();;
                                       play_button.text('Play');
                                       is_playing = false;
                                   }
                               });
    disableControlButton(play_button);
    controlButtonClickCallback(record_button,
                               function () {
                                   if (!is_recording) {
                                       disableControlButton(play_button);
                                       is_recording = true;
                                       var div = createDiv()
                                           .hide()
                                           .appendTo('body')
                                           .load('http://localhost:8008/cgi-bin/record.py',
                                                 finished_recording)
                                           .remove();
                                       record_button.text('Stop');
                                   } else {
                                       createDiv()
                                           .hide()
                                           .appendTo('body')
                                           .load('http://localhost:8008/cgi-bin/stop_recording.py')
                                           .remove();
                                       record_button.text('Record');
                                   }
                               });
}

function setUpAudioButtons(karma) {
    setUpPlayButton(karma);
    setUpRecordingButtons(karma);
}

function setUpPlayAgain(karma, start_game) {
    controlButtonClickCallback($('#linkPlayAgain'),
                               function () {
                                   start_game(karma, $('#content'));
                               });
}

/*
 * initialize is called once before the game is started. It is passed
 * the karma object as an argument.
 * Each time a game is started or restarted, start_game is called
 * with the karma object as an argument.
 */
function setUpLesson(initialize, start_game) {
    $(function () {
          setSelectable($('body'), false);

          $('#linkPrevLesson').hide();
          $('#linkNextLesson').hide();
          $("#linkCheck").hide();
		  disableImageDragging("#lesson_title img");
          try{
          var  karma = lesson_karma();
          }catch(e){alert(e.code+' '+e.message)};
          
          var $content = $('#content'); // TBD: error if absent
          karma.ready(
              function () {
                  setUpLinkBackLesson();
                  setUpPlayAgain(karma, start_game);
                  initialize(karma, $content);
                  setSelectable($('input'), true);
              });
      });
}

function setUpMultiScreenLesson(draw_screen_fns, initialize, start_game) {
    $(function () {
          setSelectable($('body'), false);
          for(var i=0;i<draw_screen_fns.length;i++){
              n=i+1;
              var pagelink='link'+n;
              $('<div>',{
                  class:pagelink+' botbtn_left',
                  id:pagelink,
                  page:i,
                  title:pagelink,
                  click:function(){
                     id = $(this).attr('id');
                     current_screen = $(this).attr('page');
                     updateScreen();
                  },
              })
              .appendTo('#footer')
          };
          $('#linkPrevLesson').hide();
          $('#linkNextLesson').hide();
          $("#linkCheck").hide();
          disableImageDragging("#lesson_title img");
          setUpPlayAgain(karma, start_game);

          var karma = lesson_karma();
          var $content = $('#content'); // TBD: error if absent
          var current_screen = 0;

          var gotoFirstScreen = function() {
              if (initialize) {
                  initialize();
              }
              current_screen = 0;
              updateScreen();
          };

          var updateScreen = function () {
              $content.empty();

              if (current_screen == 0) {
                  $('#linkPrevLesson').hide();
              } else {
                  $('#linkPrevLesson').show();
              }
              if (current_screen == draw_screen_fns.length - 1) {
                  $('#linkNextLesson').hide();
              } else {
                  $('#linkNextLesson').show();
              }
              draw_screen_fns[current_screen](karma, $content);
              setSelectable($('input'), true);
          };

          $('#linkNextLesson')
              .click(function () {
                         if (karma.audio.trigger) {
                             karma.audio.trigger.play();
                         }
                         ++current_screen;
                         updateScreen();
                     });
          $('#linkPrevLesson')
              .click(function () {
                         if (karma.audio.trigger) {
                             karma.audio.trigger.play();
                         }
                         --current_screen;
                         updateScreen();
                     });

          karma.ready(
              function () {
                  setUpLinkBackLesson();
                  setUpPlayAgain(karma, gotoFirstScreen);
                  gotoFirstScreen();
              });
      });
}


function setSelectable(target, is_selectable) {
    $(target).map(function(index, elem){
        setElementSelectable(elem, is_selectable);
    });
}

function setElementSelectable(target, is_selectable) {
    if (is_selectable != true) is_selectable = false;

    if (typeof target.onselectstart != 'undefined') { //IE
        target.onselectstart = function () { return is_selectable; };
    } else if (typeof target.style.MozUserSelect != 'undefined') { //Firefox
        target.style.MozUserSelect = is_selectable ? 'text' : '-moz-none';
    } else if (typeof target.style.KhtmlUserSelect != 'undefined') { //Webkit
        target.style.KhtmlUserSelect = is_selectable ? 'element' : 'none';
    } else { //Opera
        target.onmousedown = function () { return is_selectable; };
    }
    if (!is_selectable){
        target.style.cursor = 'default';
    }
}

function disableImageDragging(img) {
    $(img).mousedown(function (event) { event.preventDefault(); });
}

// TBD: move to Karma
function randomElement(collection) {
    return collection[Karma.random(0, collection.length - 1)];
}

// TBD: move to Karma
function range(lower, upper) {
    var result = [];
    for (var i = lower; i < upper; ++i) {
        result.push(i);
    }
    return result;
}

Karma. createImg = function (name, disable_dragging) {
    disable_dragging = typeof(disable_dragging) != 'undefined' ? disable_dragging : true;
    if (!this.image[name]) {
        alert('Missing image: ' + name);
    }
    var result = $(document.createElement('img'))
        .attr('src', this.image[name].src);
    if (disable_dragging) {
        disableImageDragging(result);
    }
    return result;
};

Karma.createVideo = function (name) {
    if (!this.video[name]) {
        alert('Missing video: ' + name);
    };
    var result = $(document.createElement('video'))
        .attr('src', this.video[name].src);
    return result;
};


Karma.play = function (media_name) {
    if (this.audio[media_name]) {
        this.audio[media_name].play();
    } else if (this.video[media_name]) {
        this.video[media_name].play();
    } else {
        alert('Missing media file: ' + media_name);
    };
};

Karma.pause = function (media_name) {
    if (this.audio[media_name]) {
       	this.audio[media_name].pause();
    } else if (this.video[media_name]) {
        this.video[media_name].pause();
    } else {
        alert('Missing media file: ' + media_name);
    };
};

Karma.random = Karma.rand;

function createDiv(id) {
    var result = $(document.createElement('div'));
    if (typeof(id) != 'undefined') {
        result.attr('id', id);
    }
    return result;
}

// Return 'n' elements from 'all', amongst which 'x'.
function randomElementsIncluding(all, x, n) {
    var others = all.filter(function (y) { return x != y; });
    var result = Karma.shuffle(others).slice(0, n - 1);
    result.push(x);
    return Karma.shuffle(result);
}

function extend(object, properties) {
    for (prop in properties) {
        if (properties.hasOwnProperty(prop)) {
            object[prop] = properties[prop];
        }
    }
    return object;
}

function toBeOverridden(method) {
    return function () {
        alert('Override ' + method);
    };
}

function capitalize(str) {
    return str[0].toUpperCase() + str.slice(1);
}

/*
 * Simple Drag and Drop:
 *  - you can drag the draggables to a droppable and drop it.
 *  - there can only be one draggable per droppable.
 *  - if you drop a draggable where there is no (free) droppable it will
 *    revert its position.
 *  - you can drag a previously dropped draggable.
 *  - once dropped the draggable will center itself on the droppable.
 *  - the dropHover class is removed if a droppable is occupied.
 *
 * The options_draggable argument accepts the same options as a
 * ui.draggable, except start/stop.
 *
 * The options_droppable argument accepts the same options as a
 * ui.draggable, except drop.
 * It takes an extra option dropSuccess, a callback that will be
 * invoked on a successful drop.
 */
function enableSimpleDragAndDrop(draggables,
                                 options_draggable,
                                 droppables,
                                 options_droppable) {
    var vacateDroppable = function (draggable) {
        var droppable = draggable.data('droppable');
        if (droppable) {
            droppable.data('draggable', null);
            draggable.data('droppable', null);
            var hover_class = options_droppable.hoverClass;
            if (hover_class) {
                droppable.droppable('option',
                                    'hoverClass',
                                    hover_class);
            }
        }
    };
    var revertOnMissedDrop = function (draggable) {
        if (!draggable.data('droppable')) {
            draggable.animate({ left: 0, top: 0 });
        }
    };
    $(draggables).draggable(
        extend(options_draggable,
               {
                   start: function (event, ui) {
                       vacateDroppable(ui.helper);
                   },
                   stop: function (event, ui) {
                       revertOnMissedDrop(ui.helper);
                   }
               })
    );
    var isVacant = function (droppable) {
        return !droppable.data('draggable');
    };
    var occupy = function (droppable, draggable) {
        droppable.data('draggable', draggable);
        draggable.data('droppable', droppable);
        draggable.position({ my: 'center', at: 'center', of: droppable });
        droppable.droppable('option', 'hoverClass', '');
    };
    $(droppables).droppable(
        extend(
            options_droppable,
            {
                drop: function (event, ui) {
                    var droppable = $(this);
                    var draggable = ui.draggable;
                    if (isVacant(droppable)) {
						allowDrop = true;
						if ( options_droppable.dropTest ){
							allowDrop = options_droppable.dropTest.apply(this, [event, ui]);
						}
						if ( allowDrop != false ){
							occupy(droppable, draggable);
							var success = options_droppable.dropSuccess;
							if (success) {
								success.apply(this, [event, ui]);
							}
						}
                    }
                }
            }
        )
    );
}

function objKeys(obj) {
    var keys = [];
    for (prop in obj) {
        if (obj.hasOwnProperty(prop)) {
            keys.push(prop);
        }
    }
    return keys;
}

function constantly(x) {
    return function () { return x; };
}

function identity(x) {
    return x;
}

function toRoman(x) {
    var mapping = [
        { roman: 'M', arabic: 1000 },
        { roman: 'CM', arabic: 900 },
        { roman: 'D', arabic: 500 },
        { roman: 'CD', arabic: 400 },
        { roman: 'C', arabic: 100 },
        { roman: 'XC', arabic: 90 },
        { roman: 'L', arabic: 50 },
        { roman: 'XL', arabic: 40 },
        { roman: 'X', arabic: 10 },
        { roman: 'IX', arabic: 9 },
        { roman: 'V', arabic: 5 },
        { roman: 'IV', arabic: 4 },
        { roman: 'I', arabic: 1 }
    ];
    var i = 0;
    var result = [];
    while (x > 0) {
        var arabic = mapping[i].arabic;
        if (arabic <= x) {
            result.push(mapping[i].roman);
            x -= arabic;
        } else {
            ++i;
        }
    }
    return String.prototype.concat.apply('', result);
}
