function initialize(karma, content) {
}

function longestPrefixLength(words) {
    var result = 0;
    words.forEach(function (word) {
                      result = Math.max(result, word.indexOf('_'));
                  });
    return result;
}

function longestSuffixLength(words) {
    var result = 0;
    words.forEach(function (word) {
                      result = Math.max(result,
                                        word.length - word.lastIndexOf('_') - 1);
                  });
    return result;
}

function repeat(string, n) {
    var result = '';
    for (var i = 0; i < n; ++i) {
        result += string;
    }
    return result;
}

function align(word, prefix_length, suffix_length) {
    var parts = word.split('_');
    var result = '';
    result += repeat('*', prefix_length - parts[0].length);
    result += parts[0];
    result += parts[1];
    result += parts[2];
    result += repeat('*', suffix_length - parts[2].length);
    return result;
}

function createTable(task) {
    var words = task.map(function (x) { return x.answer; });
    var prefix_length = longestPrefixLength(words);
    var suffix_length = longestSuffixLength(words);
    var table = $(document.createElement('table'));
    var createCell = function (letter, i) {
        var result = $(document.createElement('td'))
            .addClass('cell');
        if (letter == '*') {
            result.addClass('padding');
        } else {
            var input = $(document.createElement('input'))
                .attr({ type: 'text',
                        maxlength: 1 })
                .clickable(function () { $(this).select(); })
                .keypress(function (event) {
                          })
                .data('verify_fn',
                      function () {
                          var x = input[0].value;
                          if (!x || (x.toLowerCase() != letter.toLowerCase())) {
                              $(input).addClass('incorrect');
                              input[0].value = letter;
                          }
                      })
                .appendTo(result);
            if (i == prefix_length) {
                result.addClass('vertical');
                input.addClass('vertical');
            }
        }
        return result;
    };
    var createRow = function (word) {
        var tr = $(document.createElement('tr'))
            .appendTo(table);
        var aligned = align(word, prefix_length, suffix_length);
        return $(Array.prototype.map.apply(aligned, [createCell]))
            .appendTo(tr);
    };
    words.map(createRow);
    return table;
}

function verify() {
    $('input').map(function (index, x) {
                       $(x).data('verify_fn')();
                   });
}

function startGame(karma, content) {
    content.empty();
    var descriptions = createDiv('descriptions')
        .appendTo(content);
    task.forEach(function (x) {
                     createDiv()
                         .addClass('description')
                         .append(x.description)
                         .appendTo(descriptions);
                 });
    createDiv('grid')
        .appendTo(content)
        .append(createTable(task));
    createDiv('checkButton')
        .append('Check')
        .clickable(function () {
                       $('input').attr('disabled', true);
                       verify();
                       $(this)
                           .unclickable()
                           .hide();
                   })
        .appendTo(content);
}
