function initialize(karma, content) {
}

var dropped_map = {};

function removeDropped(droppable) {
    for (var key in dropped_map) {
        dropped_map[key] = dropped_map[key].filter(function (x) {
                                                       return x != droppable;
                                                   });
    }
}

function addDropped(key, droppable) {
    removeDropped(droppable);
    var dropped_on_key = dropped_map[key];
    dropped_on_key.push(droppable);
    dropped_map[key] = dropped_on_key;
}

function check(karma) {
    for (var key in dropped_map) {
        var val = dropped_map[key];
        if (val.length != 1 || key != val[0]) {
            return;
        }
    }
    karma.play('correct');
    $('.right')
        .draggable('disable')
        .addClass('correct');
}

function startGame(karma, content) {
    var pairs_div = createDiv('pairs');
    var left_div = createDiv('lefts')
        .appendTo(pairs_div);
    var blanks_div = createDiv('blanks')
        .appendTo(pairs_div);
    var right_div = createDiv('rights')
        .appendTo(pairs_div);
    pairs.forEach(function (pair) {
                      createDiv()
                          .addClass('left')
                          .append(pair[0])
                          .appendTo(left_div);
                      createDiv()
                          .addClass('blank')
                          .droppable(
                              {
                                  tolerance: 'intersect',
                                  drop: function (event, ui) {
                                      var draggable = $(ui.draggable[0]);
                                      draggable.position({ my: 'center',
                                                           at: 'center',
                                                           of: $(this) });
                                      addDropped(pair[1], draggable.data('key'));
                                      check(karma);
                                  }
                              })
                          .appendTo(blanks_div);
                      dropped_map[pair[1]] = [];
                  });
    Karma.shuffle(pairs).forEach(function (pair) {
                                     createDiv()
                                         .addClass('right')
                                         .append(pair[1])
                                         .draggable({revert: 'invalid'})
                                         .data('key', pair[1])
                                         .appendTo(right_div);
                                 });
    pairs_div.appendTo(content);
}
