function initialize() {
    scoreboardInitialize();
    scoreboardReset();
}

function createChoice(options, correct) {
    var result = $(document.createElement('span'))
        .addClass('choices');
    var correct_element;
    var option_elements =
        options.map(function (option, index) {
                        if (index != 0) {
                            result.append('/');
                        }
                        var element = $(document.createElement('span'))
                            .addClass('choice')
                            .addClass('virgin')
                            .append(option)
                            .click(function () {
                                       option_elements.map(function (x) {
                                                               x
                                                                   .unbind('click')
                                                                   .removeClass('virgin');
                                                               });
                                       if (option == correct) {
                                           scoreboardHit();
                                           correct_element.addClass('correct');
                                       } else {
                                           scoreboardMiss();
                                           correct_element.addClass('correct');
                                           $(this).addClass('incorrect');
                                           // TBD: strike through
                                       }
                                   })
                            .appendTo(result);
                        if (option == correct) {
                            correct_element = element;
                        }
                        return element;
                    });
    return result;
}

function showTask(karma, content, task) {
    var result = createDiv('task');
    var parts = task.text.split('_');
    for (var i = 0; i < parts.length - 1; ++i) {
        result.append(parts[i]);
        result.append(createChoice(task.choices[i].options,
                                    task.choices[i].correct));
    }
    result.append(parts[parts.length - 1]);
    return result;
}

setUpMultiScreenLesson(
    tasks.map(function (task) {
                  return function (karma, content) {
                      content.append(showTask(karma, content, task));
                  };
              }),
    initialize);

/*
 * TBD:
 * - when navigating between screens, remember whether questions were already answered. Otherwise the total score is not really meaningful
 * - only allow navigating to the next screen when a screen is fully answered
 * - layout
 * - pictures
 * - in case of incorrect answer: correct answer should maybe not be green (easily confused with correct answer). Maybe underline?
 */
