function createScreen(karma, content, sentence) {
    var sentence_div = createDiv()
        .addClass('sentence');
    if (sentence.image) {
        karma.createImg(sentence.image)
            .addClass('image')
            .appendTo(sentence_div);
    }
    var parts_div = createDiv()
        .addClass('parts')
        .appendTo(sentence_div);
    var part_divs = sentence.parts.map(function (part) {
                                           return createDiv()
                                               .addClass('part')
                                               .append(part);
                                       });
    var isCorrectOrder = function () {
        var parts = $('.part').get();
        for (var i = 0; i < parts.length; ++i) {
            console.log($(parts[i]).html());
            console.log(sentence.parts[i]);
            if ($(parts[i]).html() != sentence.parts[i]) {
                return false;
            }
        }
        return true;
    };
    var checkCorrect = function () {
        if (isCorrectOrder()) {
            $('.part')
                .draggable('disable')
                .droppable('disable')
                .addClass('correct');
        }
    };
    var zmax = 0;
    var bringToFront = function (el) {
        $(el).css('zIndex', ++zmax);
    };
    $(Karma.shuffle(part_divs)).appendTo(parts_div);
    createDiv()
        .addClass('point')
        .append('.')
        .appendTo(parts_div);
    sentence_div.appendTo(content);
    var adjustPositions = function(from, to) {
        var delta = to.width() + 8;
        var parts = $('.part');
        var left = 0;
        for (var i = 0; i < parts.length; ++i) {
            var part = $(parts[i]);
            if (part.get()[0] == from.get()[0]) {
                left += delta;
            }
            if (part.get()[0] == to.get()[0]) {
                left -= delta;
            }
            part.css({left: left});
        }
    };
    $('.part')
        .draggable({
                       containment: '#content',
                       start: function (event, ui) {
                           bringToFront(this);
                       },
                       stop: function (event, ui) {
                           $('.part')
                               .css({left: 0, top: 0});
                       }
                   })
        .droppable({
                       tolerance: 'intersect',
                       over: function (event, ui) {
                           console.log('over');
                           adjustPositions($(this), ui.draggable);
                       },
                       drop: function (event, ui) {
                           $('.part')
                               .css({left: 0, top: 0});
                           ui.draggable.insertBefore($(this));
                           checkCorrect();
                       }
                   });
}

setUpMultiScreenLesson(sentences.map(function (sentence) {
                                         return function (karma, content) {
                                             createScreen(karma, content, sentence);
                                         };
                                     }));
