function charCmp(x1, x2) {
    var c1 = x1.charCodeAt(0);
    var c2 = x2.charCodeAt(0);
    return c1 == c2 ? 0 : (c1 < c2 ? -1 : 1);
}

function showFeedback(letters, typed) {
    letters = letters.slice();
    letters.forEach(function (letter) { letter.span.removeClass('used'); });
    typed.sort(charCmp);
    var i = 0;
    var j = 0;
    while (i < letters.length && j < typed.length) {
        var l1 = letters[i];
        var l2 = typed[j];
        if (l1.letter == l2) {
            l1.span.addClass('used');
            i++;
            j++;
        } else if (l1.letter < l2) {
            i++;
        } else {
            j++;
        }
    }
    while (j < typed.length) {
        j++;
    }
}

function showAnagramTask(karma, content, spec) {
    var result = createDiv().addClass('task');
    result.append(karma.createImg(spec.word).addClass('image'));
    var word = createDiv()
        .addClass('word')
        .appendTo(result);
    var letters = [];
    Array.prototype.forEach.apply(spec.anagram,
                                  [function (letter) {
                                       var span =  $(document.createElement('span'))
                                           .append(letter)
                                           .appendTo(word);
                                       letters.push({
                                                        letter: letter,
                                                        span: span
                                                    });
                                   }]);
    letters.sort(function (x, y) { return charCmp(x.letter, y.letter); });
    createDiv()
        .addClass('answer')
        .append($(document.createElement('input'))
                .attr({ type: 'text',
                        maxlength: spec.word.length })
                .clickable(function () { $(this).select(); })
                // TBD: backspace doesn't trigger keypress on Chrome...
                .keypress(function (event) {
                              var ch = String.fromCharCode(event.which);
                              var typed = this.value.split('');
                              typed.push(ch);
                              showFeedback(letters, typed);
                              if (spec.word.substring(0, typed.length) != this.value + ch) {
                                  $(this).addClass('incorrect');
                              } else {
                                  $(this).removeClass('incorrect');
                                  if (typed.length == spec.word.length) {
                                      karma.play('correct');
                                      $('.answer')
                                          .empty()
                                          .append(spec.word);
                                  }
                              }
                          }))
        .appendTo(result);
    content.append(result);
}

function startLesson(karma, content) {
}

setUpMultiScreenLesson(anagrams.map(function (spec) {
                                        return function (karma, content) {
                                            showAnagramTask(karma, content, spec);
                                        };
                                    }));
